• Poj(3259),SPFA,判负环


    题目链接:http://poj.org/problem?id=3259

    Wormholes
    Time Limit: 2000MS   Memory Limit: 65536K
    Total Submissions: 44090   Accepted: 16203

    Description

    While exploring his many farms, Farmer John has discovered a number of amazing wormholes. A wormhole is very peculiar because it is a one-way path that delivers you to its destination at a time that is BEFORE you entered the wormhole! Each of FJ's farms comprises N (1 ≤ N ≤ 500) fields conveniently numbered 1..NM (1 ≤ M ≤ 2500) paths, and W (1 ≤ W ≤ 200) wormholes.

    As FJ is an avid time-traveling fan, he wants to do the following: start at some field, travel through some paths and wormholes, and return to the starting field a time before his initial departure. Perhaps he will be able to meet himself :) .

    To help FJ find out whether this is possible or not, he will supply you with complete maps to F (1 ≤ F ≤ 5) of his farms. No paths will take longer than 10,000 seconds to travel and no wormhole can bring FJ back in time by more than 10,000 seconds.

    Input

    Line 1: A single integer, FF farm descriptions follow. 
    Line 1 of each farm: Three space-separated integers respectively: NM, and W 
    Lines 2..M+1 of each farm: Three space-separated numbers (SET) that describe, respectively: a bidirectional path between S and E that requires T seconds to traverse. Two fields might be connected by more than one path. 
    Lines M+2..M+W+1 of each farm: Three space-separated numbers (SET) that describe, respectively: A one way path from S to E that also moves the traveler back T seconds.

    Output

    Lines 1..F: For each farm, output "YES" if FJ can achieve his goal, otherwise output "NO" (do not include the quotes).

    Sample Input

    2
    3 3 1
    1 2 2
    1 3 4
    2 3 1
    3 1 3
    3 2 1
    1 2 3
    2 3 4
    3 1 8

    Sample Output

    NO
    YES

    Hint

    For farm 1, FJ cannot travel back in time. 
    For farm 2, FJ could travel back in time by the cycle 1->2->3->1, arriving back at his starting location 1 second before he leaves. He could start from anywhere on the cycle to accomplish this.
     
    题意:2个案例,3个点,3条路,1个虫洞,路是双向的,虫洞是单向的,单向的路为负,起点为1,看能不能穿越。
    分析:SPFA判负环。
    没有看模板,直接上代码,结果发现不知道WA了多少次,实在搞不下去了,最后,佳鑫大神帮我Debug了,我在建图的时候head初始化了,结果在SPFA里面有初始化为-1了,真是害死我了,最后还是RE了一次,数组开小了。不管怎么样,Dijkstra,SPFA,Floyd,Kruskal都可以不用看模板了,很开心。
    #include <stdio.h>
    #include<iostream>
    #include <queue>
    #include <string.h>
    
    using namespace std;
    
    #define INF 0x3f3f3f3f
    
    int n,m,t;
    
    struct Edge
    {
        int v;
        int w;
        int next;
    } edge[300000];
    
    int NE = 0;
    
    int dis[5500];
    int head[5500];
    bool vis[5500];
    int cnt[5500];
    
    void add(int u,int v,int d)
    {
        edge[NE].v = v;
        edge[NE].w = d;
        edge[NE].next = head[u];
        head[u]= NE++;
    }
    
    bool SPFA()
    {
        for(int i=1; i<=n; i++)
        {
            dis[i] = INF;
            vis[i] = false;
            cnt[i] = 0;
        }
    
        dis[1] = 0;
        vis[1] = true;
        cnt[1] = 1;
        queue<int>  Q;
        Q.push(1);
    
        while(!Q.empty())
        {
            int u=Q.front();
            Q.pop();
            vis[u]=false;
            for(int i=head[u]; i!=-1; i=edge[i].next)
            {
    
                if(dis[edge[i].v]>dis[u]+edge[i].w)
                {
                    dis[edge[i].v] = dis[u] + edge[i].w;
                    if(!vis[edge[i].v])
                    {
                        vis[edge[i].v] = true;
                        Q.push(edge[i].v);
                        if(++cnt[edge[i].v]>n)
                            return true;
                    }
                }
            }
        }
        return false;
    }
    
    int main()
    {
        //freopen("input.txt","r",stdin);
        int cases;
        scanf("%d",&cases);
        while(cases--)
        {
    
            NE = 0;
            memset(head,-1,sizeof(head));
            scanf("%d%d%d",&n,&m,&t);
    
            for(int i=0; i<m; i++)
            {
                int a,b,d;
                scanf("%d%d%d",&a,&b,&d);
                add(a,b,d);
                add(b,a,d);
            }
    
            for(int i=0; i<t; i++)
            {
                int a,b,d;
                scanf("%d%d%d",&a,&b,&d);
                add(a,b,-d);
            }
    
            if(SPFA())
                printf("YES
    ");
            else printf("NO
    ");
        }
        return 0;
    }
     
  • 相关阅读:
    libcurl库进行http通讯-开篇
    hdu4059The Boss on Mars 容斥原理
    “最大子序列和”算法 java
    Android 的事件传递机制,详解
    POJ
    hdu 5652 India and China Origins
    解决Swap file &quot;.ceshi.c.swp&quot; already exists!问题
    3DMax脚本插件--改动材质&amp;贴图名称
    ASP.NET MVC+Bootstrap 实现短信验证
    [从头学数学] 第176节 概率
  • 原文地址:https://www.cnblogs.com/TreeDream/p/5749447.html
Copyright © 2020-2023  润新知